<?
//////////////////////////////////////////////////////////////////////////
//	"sdblib.inc"
//------------------------------------------------------------------------
//	$Id: sdblib.inc 165 2006-05-06 01:21:59Z taro $
//////////////////////////////////////////////////////////////////////////

	if ( class_exists("PgSql"     ) == FALSE ) include("pgsql.inc");

	define("SDB_DEFAULT_HOST"  , "localhost");
	define("SDB_DEFAULT_PORT"  , "5432");
	define("SDB_DEFAULT_USER"  , "sdb_user");
	define("SDB_DEFAULT_PASS"  , "sdb_pass");
	define("SDB_DEFAULT_DBNAME", "sdb");
	define("SDB_DEV_TBLNAME"   , "dev");
	define("SDB_WAT_TBLNAME"   , "wat");
	define("SDB_DATE_FORMAT"   , "Y-m-d H:i:s");

	$SdbDevTbl = array(
		"dev_id"           => array("TYPE" => "serial4"     ,  "LABEL" => "device-id"         , "PRIMARY"=>TRUE),
		"dev_model"        => array("TYPE" => "varchar(64)" ,  "LABEL" => "model"             , "INDEX"=>TRUE),
		"dev_serial"       => array("TYPE" => "varchar(64)" ,  "LABEL" => "serial"            , "INDEX"=>TRUE),
		"dev_hostname"     => array("TYPE" => "varchar(64)" ,  "LABEL" => "hostname"          , "INDEX"=>TRUE),
		"dev_groupname"    => array("TYPE" => "varchar(64)" ,  "LABEL" => "groupname"         , "INDEX"=>TRUE),
		"dev_smt_tblname"  => array("TYPE" => "varchar(64)" ,  "LABEL" => "table name"        ),
		"dev_f_disable"    => array("TYPE" => "bool"        ,  "LABEL" => "disable"           ),
		"dev_blocksize"    => array("TYPE" => "int4"        ,  "LABEL" => "block-size"        ),
		"dev_blocknumber"  => array("TYPE" => "int8"        ,  "LABEL" => "block-number"      ),
		"dev_ts_begin"     => array("TYPE" => "timestamp"   ,  "LABEL" => "begin date-time"   ),
		"dev_ts_last"      => array("TYPE" => "timestamp"   ,  "LABEL" => "last date-time"    ),
		"dev_user_stt"     => array("TYPE" => "int4"        ,  "LABEL" => "user status"       ),
		"dev_user_id"      => array("TYPE" => "int4"        ,  "LABEL" => "user id"           ),
		"dev_user_pass"    => array("TYPE" => "varchar(64)" ,  "LABEL" => "user pass"         ),
		"dev_user_ts"      => array("TYPE" => "timestamp"   ,  "LABEL" => "user date-time"    ),
		"dev_memo"         => array("TYPE" => "text"        ,  "LABEL" => "remark"            ),
	);
	define("SDB_DEV_USER_STT_ACTIVE"    ,  0);
	define("SDB_DEV_USER_STT_TERMINATE" ,  1);
	define("SDB_DEV_USER_STT_NUM"       ,  2);
	define("SDB_DEV_MEMO_LENGTH"        ,256);

	$SdbSmtTbl = array(
		"smt_ts"           => array("TYPE" => "timestamp"   ,  "LABEL" => "date-time"         , "PRIMARY"=>TRUE),
		"smt_dev_id"       => array("TYPE" => "int4"        ,  "LABEL" => "device-id"         , "PRIMARY"=>TRUE),
		"smt_attr_id"      => array("TYPE" => "int2"        ,  "LABEL" => "attribute id#"     , "PRIMARY"=>TRUE),
		"smt_value"        => array("TYPE" => "int2"        ,  "LABEL" => "value"             ),
		"smt_worst"        => array("TYPE" => "int2"        ,  "LABEL" => "worst"             ),
		"smt_threshold"    => array("TYPE" => "int2"        ,  "LABEL" => "threshold"         ),
		"smt_flags"        => array("TYPE" => "int2"        ,  "LABEL" => "flags"             ),
		"smt_raw_value"    => array("TYPE" => "int8"        ,  "LABEL" => "raw value"         ),
		"smt_raw_data"     => array("TYPE" => "int8"        ,  "LABEL" => "raw data"          ),
	);

	$SdbWatTbl = array(
		"wat_id"           => array("TYPE" => "serial4"     ,  "LABEL" => "watch-id"          , "PRIMARY"=>TRUE),
		"wat_priority"     => array("TYPE" => "int2"        ,  "LABEL" => "priority"          ),
		"wat_model"        => array("TYPE" => "varchar(64)" ,  "LABEL" => "model"             ),
		"wat_serial"       => array("TYPE" => "varchar(64)" ,  "LABEL" => "serial"            ),
		"wat_attr_id"      => array("TYPE" => "int2"        ,  "LABEL" => "attribute id#"     ),
		"wat_type"         => array("TYPE" => "int2"        ,  "LABEL" => "type"              ),
		"wat_f_disable"    => array("TYPE" => "bool"        ,  "LABEL" => "disable"           ),
		"wat_warn"         => array("TYPE" => "int2"        ,  "LABEL" => "warnning level"    ),
		"wat_op"           => array("TYPE" => "varchar(32)" ,  "LABEL" => "operator"          ),
		"wat_right"        => array("TYPE" => "varchar(64)" ,  "LABEL" => "right value"       ),
	);

	define("SMART_VENDOR_GENERAL", 1);
	define("SMART_VENDOR_FUJITSU", 2);
	define("SMART_VENDOR_HGST"   , 3);
	define("SMART_VENDOR_IBM"    , 4);
	define("SMART_VENDOR_MAXTOR" , 5);
	define("SMART_VENDOR_SAMSUNG", 6);
	define("SMART_VENDOR_SEAGATE", 7);
	define("SMART_VENDOR_TOSHIBA", 8);
	define("SMART_VENDOR_WD"     , 9);

	$SdbSmartDef = array(
	array("ID"=>   1, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Raw Read Error Rate"            ),
	array("ID"=>   2, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Throughput Performance"         ),
	array("ID"=>   3, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Spin Up Time"                   ),
	array("ID"=>   4, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Start/Stop Count"               ),
	array("ID"=>   5, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Reallocated Sectors Count"      ),
	array("ID"=>   6, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Read Channel Margin"            ),
	array("ID"=>   7, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Seek Error Rate"                ),
	array("ID"=>   8, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Seek Time Performance"          ),
	array("ID"=>   9, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Power-On Hours"                 ),
	array("ID"=>  10, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Spin Retry Count"               ),
	array("ID"=>  11, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Recalibration Retries"          ),
	array("ID"=>  12, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Device Power Cycle Count"       ),
	array("ID"=>  13, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Soft Read Error Rate"           ),
	array("ID"=> 191, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Gsense Error Rate"              ),
	array("ID"=> 192, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Power off Retract Count"        ),
//	array("ID"=> 192, "VENDOR"=>SMART_VENDOR_FUJITSU, "TEXT"=>"Emergency Retract Cycles"       ),	// Fujitsu
	array("ID"=> 193, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Load/Unload Cycle Count"        ),
	array("ID"=> 194, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Temperature"                    ),
	array("ID"=> 195, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Hardware ECC Recovered"         ),
	array("ID"=> 196, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Reallocation Event Count"       ),
	array("ID"=> 197, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Current Pending Sector Count"   ),
	array("ID"=> 198, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Uncorrectable Sector Count"     ),
	array("ID"=> 199, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"UltraDMA CRC Error Rate"        ),
	array("ID"=> 200, "VENDOR"=>SMART_VENDOR_WD     , "TEXT"=>"Multi Zone Error Rate"          ),	// Western Digital
	array("ID"=> 200, "VENDOR"=>SMART_VENDOR_FUJITSU, "TEXT"=>"Write Error Rate"               ),	// Fujitsu
	array("ID"=> 201, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Soft Read Error Rate"           ),
	array("ID"=> 202, "VENDOR"=>SMART_VENDOR_MAXTOR , "TEXT"=>"Data Address Mark Errors"       ),	// Maxtor
	array("ID"=> 202, "VENDOR"=>SMART_VENDOR_FUJITSU, "TEXT"=>"TA Increase Count"              ),	// Fujitsu
	array("ID"=> 203, "VENDOR"=>SMART_VENDOR_MAXTOR , "TEXT"=>"ECC Errors"                     ),	// Maxtor
	array("ID"=> 203, "VENDOR"=>SMART_VENDOR_FUJITSU, "TEXT"=>"Run Out Cancel"                 ),	// Fujitsu
	array("ID"=> 204, "VENDOR"=>SMART_VENDOR_MAXTOR , "TEXT"=>"Soft ECC Correction"            ),	// Maxtor
	array("ID"=> 204, "VENDOR"=>SMART_VENDOR_FUJITSU, "TEXT"=>"Shock Count Write Opern"        ),	// Fujitsu
	array("ID"=> 205, "VENDOR"=>SMART_VENDOR_MAXTOR , "TEXT"=>"Thermal Aspirates"              ),	// Maxtor
	array("ID"=> 205, "VENDOR"=>SMART_VENDOR_FUJITSU, "TEXT"=>"Shock Rate Write Opern"         ),	// Fujitsu
	array("ID"=> 206, "VENDOR"=>SMART_VENDOR_FUJITSU, "TEXT"=>"Flying_Height"                  ),	// Fujitsu
	array("ID"=> 207, "VENDOR"=>SMART_VENDOR_MAXTOR , "TEXT"=>"Spin High Current"              ),	// Maxtor
	array("ID"=> 208, "VENDOR"=>SMART_VENDOR_MAXTOR , "TEXT"=>"Spin Buzz"                      ),	// Maxtor
	array("ID"=> 209, "VENDOR"=>SMART_VENDOR_MAXTOR , "TEXT"=>"Offline Seek Performnce"        ),	// Maxtor
	array("ID"=> 220, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Disk Shift"                     ),
	array("ID"=> 221, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"G-Sense Error Rate"             ),
	array("ID"=> 222, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Loaded Hours"                   ),
	array("ID"=> 223, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Load/Unload Retry Count"        ),
	array("ID"=> 224, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Load Friction"                  ),
	array("ID"=> 225, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Load Cycle Count"               ),
	array("ID"=> 226, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Load-in Time"                   ),
	array("ID"=> 227, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Torque Amplification Count"     ),
	array("ID"=> 228, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Power-off Retract Count"        ),
	array("ID"=> 230, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"GMR Head Amplitude"             ),	// IBM
	array("ID"=> 231, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Temperature Celsius"            ),
	array("ID"=> 240, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Head Flying Hours"              ),
	array("ID"=> 250, "VENDOR"=>SMART_VENDOR_GENERAL, "TEXT"=>"Read Error Retry Rate"          ),
	);

class	SdbLib
{
	var					$pgsql;
	var					$dev_tblname;
	var					$wat_tblname;
	var					$debug;

	//////////////////////////////////////////////////////////////////////
	//	
	function	SdbLib()
	{
		$this->pgsql = New PgSql;
		$this->pgsql->Init();
		$this->pgsql->host     = SDB_DEFAULT_HOST;
		$this->pgsql->port     = SDB_DEFAULT_PORT;
		$this->pgsql->user     = SDB_DEFAULT_USER;
		$this->pgsql->password = SDB_DEFAULT_PASS;
		$this->pgsql->dbname   = SDB_DEFAULT_DBNAME;

		$this->dev_tblname = SDB_DEV_TBLNAME;
		$this->wat_tblname = SDB_WAT_TBLNAME;
		$this->debug = 0;
	}

	//////////////////////////////////////////////////////////////////////
	//	ǡ١

	function	DBOpen()
	{
		if ( $this->pgsql->Connect(FALSE) < 0 )
			return -1;
		return 0;
	}
	function	DBClose()
	{
		$this->pgsql->Close();
		return 0;
	}

	//////////////////////////////////////////////////////////////////////
	//	DEVICE DATA ATBLE

	function	dev_CreateTable()
	{
		global	$SdbDevTbl;

		if ( $this->debug )
		{
			$save_debug = $this->pgsql->debug;
			$this->pgsql->debug = 1;
		}
		$addtbl = "UNIQUE (dev_model,dev_serial)";
		$this->pgsql->lib_CreateTable($this->dev_tblname, $SdbDevTbl, $addtbl);
		if ( $this->debug )
			$this->pgsql->debug = $save_debug;
	}
	function	dev_DropTable()
	{
		global	$SdbDevTbl;

		if ( $this->debug )
		{
			$save_debug = $this->pgsql->debug;
			$this->pgsql->debug = 1;
		}

		$this->pgsql->lib_DropTable($this->dev_tblname, $SdbDevTbl);

		if ( $this->debug )
			$this->pgsql->debug = $save_debug;
	}
	function	dev_InitData(&$data, $ts_now)
	{
		global	$SdbDevTbl;

	//	$data["dev_id"         ] = 0;
		$data["dev_model"      ] = "";
		$data["dev_serial"     ] = "";
		$data["dev_hostname"   ] = "";
		$data["dev_groupname"  ] = "";
		$data["dev_smt_tblname"] = "";
		$data["dev_f_disable"  ] = FALSE;
		$data["dev_blocksize"  ] = 512;
		$data["dev_blocknumber"] = 0;
		$data["dev_ts_begin"   ] = $ts_now;
		$data["dev_ts_last"    ] = $ts_now;
		$data["dev_user_stt"   ] = 0;
		$data["dev_user_id"    ] = 0;
		$data["dev_user_pass"  ] = "";
		$data["dev_user_ts"    ] = $ts_now;
		$data["dev_memo"       ] = "";
	}

	function	dev_GetData(&$data, $where, $opt)
	{
		global	$SdbDevTbl;

		if ( ($fld = $opt["FIELDS"]) == "" )
			$fld = "*";
		if ( $opt["DISTINCT"] != "" )
			$distinct = " DISTINCT ON ({$opt["DISTINCT"]}) ";
		else
			$distinct = "";
		$sql = "SELECT {$distinct}{$fld} FROM {$this->dev_tblname} WHERE {$where}";
		if ( $opt["ORDER"] != "" )
			$sql .= " ORDER BY {$opt["ORDER"]}";
		if ( $opt["LIMIT"] > 0 )
			$sql .= " LIMIT {$opt["LIMIT"]}";
		$ret = $this->pgsql->lib_SelectSql(&$data, $sql, $SdbDevTbl);
		if ( ! $opt["LIST"] )
		{
			if ( $ret > 0 )
				$data = $data[0];
		}
		return $ret;
	}

	function	dev_InsertData(&$data)
	{
		global	$SdbDevTbl;

		$sql = $this->pgsql->lib_GetSqlInsert($this->dev_tblname, $SdbDevTbl, &$data);
		if ( $sql == "" )
			return -1;
		if ( $this->debug )
			echo "sdblib->dev_InsertData: sql = $sql<BR>\n";
		$oid = $this->pgsql->lib_ExecSqlInsert($sql);
		if ( $oid < 0 )
			return -1;
		return $oid;
	}

	function	dev_UpdateData(&$data, $where)
	{
		global	$SdbDevTbl;

		$sql = $this->pgsql->lib_GetSqlUpdate($this->dev_tblname, $SdbDevTbl, &$data, $where);
		if ( $this->debug )
			echo "sdblib->dev_UpdateData: sql = $sql<BR>\n";
		if ( $sql == "" )
			return -1;
		$ret = $this->pgsql->Exec($sql);
		if ( $ret < 0 )
			return -1;
		$ret->Term();
		return 0;
	}

	function	dev_DeleteData($where)
	{
		global	$SdbDevTbl;

		$sql = "DELETE FROM {$this->dev_tblname} WHERE {$where}";
		if ( $this->debug )
			echo "sdblib->dev_DeleteData: sql = $sql<BR>\n";
		if ( $sql == "" )
			return -1;
		$ret = $this->pgsql->Exec($sql);
		if ( $ret < 0 )
			return -1;
		$ret->Term();
		return 0;
	}

	//////////////////////////////////////////////////////////////////////
	//	SMART DATA ATBLE

	function	smt_CreateTable($smt_tblname)
	{
		global	$SdbSmtTbl;

		if ( $this->debug )
		{
			$save_debug = $this->pgsql->debug;
			$this->pgsql->debug = 1;
		}
		$this->pgsql->lib_CreateTable($smt_tblname, $SdbSmtTbl);
		if ( $this->debug )
			$this->pgsql->debug = $save_debug;
	}

	function	smt_DropTable($smt_tblname)
	{
		global	$SdbSmtTbl;

		if ( $this->debug )
		{
			$save_debug = $this->pgsql->debug;
			$this->pgsql->debug = 1;
		}

		$this->pgsql->lib_DropTable($smt_tblname, $SdbDevTbl);

		if ( $this->debug )
			$this->pgsql->debug = $save_debug;
	}

	function	smt_InitData(&$data, $ts_now)
	{
		global	$SdbSmtTbl;

		$data["smt_ts"         ] = $ts_now;
		$data["smt_dev_id"     ] = 0;
		$data["smt_attr_id"    ] = 0;
		$data["smt_value"      ] = 0;
		$data["smt_worst"      ] = 0;
		$data["smt_threshold"  ] = 0;
		$data["smt_flags"      ] = 0;
		$data["smt_raw_value"  ] = 0;
		$data["smt_raw_data"   ] = 0;
	}

	function	smt_GetData($smt_tblname, &$data, $where, $opt)
	{
		global	$SdbSmtTbl;

		if ( ($fld = $opt["FIELDS"]) == "" )
			$fld = "*";
		if ( $opt["DISTINCT"] != "" )
			$distinct = " DISTINCT ON ({$opt["DISTINCT"]}) ";
		else
			$distinct = "";
		$sql = "SELECT {$distinct}{$fld} FROM {$smt_tblname} WHERE {$where}";
		if ( $opt["ORDER"] != "" )
			$sql .= " ORDER BY {$opt["ORDER"]}";
		if ( $opt["LIMIT"] > 0 )
			$sql .= " LIMIT {$opt["LIMIT"]}";
		$ret = $this->pgsql->lib_SelectSql(&$data, $sql, $SdbSmtTbl);
		if ( ! $opt["LIST"] )
		{
			if ( $ret > 0 )
				$data = $data[0];
		}
		return $ret;
	}

	function	smt_InsertData($smt_tblname, &$data)
	{
		global	$SdbSmtTbl;

		$sql = $this->pgsql->lib_GetSqlInsert($smt_tblname, $SdbSmtTbl, &$data);
		if ( $sql == "" )
			return -1;
		if ( $this->debug )
			echo "sdblib->smt_InsertData({$smt_tblname}): sql = {$sql}<BR>\n";
		$oid = $this->pgsql->lib_ExecSqlInsert($sql);
		if ( $oid < 0 )
			return -1;
		return $oid;
	}

	function	smt_UpdateData($smt_tblname, &$data, $where)
	{
		global	$SdbSmtTbl;

		$sql = $this->pgsql->lib_GetSqlUpdate($smt_tblname, $SdbSmtTbl, &$data, $where);
		if ( $this->debug )
			echo "sdblib->smt_UpdateData({$smt_tblname}): sql = $sql<BR>\n";
		if ( $sql == "" )
			return -1;
		$ret = $this->pgsql->Exec($sql);
		if ( $ret < 0 )
			return -1;
		$ret->Term();
		return 0;
	}

	function	smt_DeleteData($smt_tblname, $where)
	{
		global	$SdbSmtTbl;

		$sql = "DELETE FROM {$smt_tblname} WHERE {$where}";
		if ( $this->debug )
			echo "sdblib->smt_DeleteData({$smt_tblname}): sql = $sql<BR>\n";
		if ( $sql == "" )
			return -1;
		$ret = $this->pgsql->Exec($sql);
		if ( $ret < 0 )
			return -1;
		$ret->Term();
		return 0;
	}

	function	GetSmartAttrName($vendor, $id)
	{
		global	$SdbSmartDef;

		$text = "";
		$tbl_num = count($SdbSmartDef);
		for ( $i = 0; $i < $tbl_num; $i++ )
		{
			if ( $SdbSmartDef[$i]["ID"] == $id )
			{
				if ( $text == "" )
					$text = $SdbSmartDef[$i]["TEXT"];
				if ( $SdbSmartDef[$i]["VENDOR"] == $vendor )
					break;
				break;
			}
		}
		return $text;
	}

	//////////////////////////////////////////////////////////////////////
	//	WATCH DATA ATBLE

	function	wat_CreateTable()
	{
		global	$SdbWatTbl;

		if ( $this->debug )
		{
			$save_debug = $this->pgsql->debug;
			$this->pgsql->debug = 1;
		}
		$this->pgsql->lib_CreateTable($this->wat_tblname, $SdbWatTbl);
		if ( $this->debug )
			$this->pgsql->debug = $save_debug;
	}
	function	wat_DropTable()
	{
		global	$SdbWatTbl;

		if ( $this->debug )
		{
			$save_debug = $this->pgsql->debug;
			$this->pgsql->debug = 1;
		}

		$this->pgsql->lib_DropTable($this->wat_tblname, $SdbWatTbl);

		if ( $this->debug )
			$this->pgsql->debug = $save_debug;
	}

	function	wat_InitData(&$data, $ts_now = "")
	{
		global	$SdbWatTbl;

	//	$data["wat_id"         ] = 0;
		$data["wat_priority"   ] = 0;
		$data["wat_model"      ] = "";
		$data["wat_serial"     ] = "";
		$data["wat_type"       ] = 0;
		$data["wat_f_disable"  ] = FALSE;
		$data["wat_warn"       ] = 0;
		$data["wat_op"         ] = "";
		$data["wat_right"      ] = "";
	}

	function	wat_GetData(&$data, $where, $opt)
	{
		global	$SdbWatTbl;

		if ( ($fld = $opt["FIELDS"]) == "" )
			$fld = "*";
		if ( $opt["DISTINCT"] != "" )
			$distinct = " DISTINCT ON ({$opt["DISTINCT"]}) ";
		else
			$distinct = "";
		$sql = "SELECT {$distinct}{$fld} FROM {$this->wat_tblname} WHERE {$where}";
		if ( $opt["ORDER"] != "" )
			$sql .= " ORDER BY {$opt["ORDER"]}";
		if ( $opt["LIMIT"] > 0 )
			$sql .= " LIMIT {$opt["LIMIT"]}";
		$ret = $this->pgsql->lib_SelectSql(&$data, $sql, $SdbWatTbl);
		if ( ! $opt["LIST"] )
		{
			if ( $ret > 0 )
				$data = $data[0];
		}
		return $ret;
	}

	function	wat_InsertData(&$data)
	{
		global	$SdbWatTbl;

		$sql = $this->pgsql->lib_GetSqlInsert($this->wat_tblname, $SdbWatTbl, &$data);
		if ( $sql == "" )
			return -1;
		if ( $this->debug )
			echo "sdblib->wat_InsertData: sql = $sql<BR>\n";
		$oid = $this->pgsql->lib_ExecSqlInsert($sql);
		if ( $oid < 0 )
			return -1;
		return $oid;
	}

	function	wat_UpdateData(&$data, $where)
	{
		global	$SdbWatTbl;

		$sql = $this->pgsql->lib_GetSqlUpdate($this->wat_tblname, $SdbWatTbl, &$data, $where);
		if ( $this->debug )
			echo "sdblib->wat_UpdateData: sql = $sql<BR>\n";
		if ( $sql == "" )
			return -1;
		$ret = $this->pgsql->Exec($sql);
		if ( $ret < 0 )
			return -1;
		$ret->Term();
		return 0;
	}

	function	wat_DeleteData($where)
	{
		global	$SdbWatTbl;

		$sql = "DELETE FROM {$this->wat_tblname} WHERE {$where}";
		if ( $this->debug )
			echo "sdblib->DeleteData: sql = $sql<BR>\n";
		if ( $sql == "" )
			return -1;
		$ret = $this->pgsql->Exec($sql);
		if ( $ret < 0 )
			return -1;
		$ret->Term();
		return 0;
	}

	//////////////////////////////////////////////////////////////////////
	//	Library

	function	CorrectValueName($src)
	{
		$dst = "";
		$len = strlen($src);
		$pos = 0;
		while ( $pos < $len )
		{
			$ch = substr($src, $pos, 1);
			$pos++;
			if ( ($ch >= 'A' && $ch <= 'Z')
			  || ($ch >= 'a' && $ch <= 'z')
			  || ($ch >= '0' && $ch <= '9')
			  || $ch == '_' )
			{
				$dst .= $ch;
			} else
			{
				$dst .= sprintf("%02X", Ord($ch));
			}
		}
		return $dst;
	}

	function	GenerateSmtTblName($devdata)
	{
		$name = sprintf("smt_%s_id%d"
		  , (string)$devdata["dev_model"]
		  , (int)$devdata["dev_id"]
		);
		return $this->CorrectValueName($name);
	}

	function	GetSmtFlagsText($opt, $stt)
	{
		return sprintf("%s%s%s%s%s%s"
		  , $stt & 0x0020 ? '1' : '-'
		  , $stt & 0x0010 ? '1' : '-'
		  , $stt & 0x0008 ? '1' : '-'
		  , $stt & 0x0004 ? '1' : '-'
		  , $stt & 0x0002 ? 'O' : '-'
		  , $stt & 0x0001 ? 'P' : '-'
		);
	}

	//////////////////////////////////////////////////////////////////////
	//	DATE/TIME
	function	GetLocalTime($st)
	{
		list($year, $month, $day, $hour, $minute, $second) = Split("[ /:.-]", $st);
	//	return "{$year}-{$month}-${day} {$hour}:{$minute}:{$second}";
		$tm = gmmktime($hour, $minute, $second, $month, $day, $year);
		return date(SDB_DATE_FORMAT, $tm);
	}

	function	GetTimeCode($ts)
	{
		$a = Split("[ /:.-]", $ts);
		if ( is_array($a) )
		{
			$year   = (int)$a[0];
			$month  = (int)$a[1];
			$day    = (int)$a[2];
			$hour   = (int)$a[3];
			$minute = (int)$a[4];
			$second = (int)$a[5];
			$tm = gmmktime($hour, $minute, $second, $month, $day, $year);
		} else
		{
			$tm = (int)$ts;
		}
		return (int)$tm;
	}

	function	GetLocalTimeCode($ts)
	{
		$a = Split("[ /:.-]", $ts);
		if ( is_array($a) )
		{
			$year   = (int)$a[0];
			$month  = (int)$a[1];
			$day    = (int)$a[2];
			$hour   = (int)$a[3];
			$minute = (int)$a[4];
			$second = (int)$a[5];
			$tm = mktime($hour, $minute, $second, $month, $day, $year);
		} else
		{
			$tm = (int)$ts;
		}
		return (int)$tm;
	}
	function	format_gmdate($tm)
	{
	 	return gmdate(SDB_DATE_FORMAT, $tm);
	}
	function	format_date($tm)
	{
	 	return date(SDB_DATE_FORMAT, $tm);
	}

//	function	GetSearchString($opt, $s)
//	{
//		$s = str_replace( array("\\"  ,"%"  , "_"  , "?", "*")
//		                , array("\\\\","\\%", "\\_", "_", "%")
//		                , trim($s) );
//		return $s;
//	}
	function	EncodeSearchString($opt, $s)
	{
		$s = str_replace( array("\\"  ,"%"  , "_"  )
		                , array("\\\\","\\%", "\\_")
		                , trim($s) );
		return $s;
	}

}; // end of SdbLib

?>
