//////////////////////////////////////////////////////////////////////////
//	"sqll_res.cpp"
//------------------------------------------------------------------------
//	$Id: sql_res.cpp 4 2006-03-01 22:26:13Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"sqllib.h"
#if	defined(SQLLIB_SUPPORT_PGLIB)
# include	<pglib.h>
#endif

SqlLib::Result::Result()
{
	this->rep = NULL;
}

SqlLib::Result::Result(SqlLib::DBType dbtype)
{
	this->rep = new Rep;
	this->create(dbtype);
}

SqlLib::Result::~Result()
{
	if ( this->rep != NULL )
	{
		if ( --(this->rep->ref) == 0 )
		{
			this->destroy();
			delete this->rep;
			this->rep = NULL;
		}
	}
}

int		SqlLib::Result::create(SqlLib::DBType dbtype)
{
	if ( this->check_rep() < 0  )
		return -1;
	if ( this->rep->dbtype != DBTYPE_NONE )
		this->destroy();

	switch ( dbtype )
	{
#if	defined(SQLLIB_SUPPORT_PGLIB)
	case DBTYPE_PGLIB:
		this->rep->dbtype = DBTYPE_PGLIB;
		if ( (this->rep->db.pg_res = new PgLib::Result) == NULL )
			return -1;
		break;
#endif
	default:
		this->rep->dbtype = DBTYPE_NONE;
		this->rep->db.work = NULL;
		break;
	}
	return 0;
}

void	SqlLib::Result::destroy(void)
{
	if ( this->rep != NULL )
	{
		switch ( this->rep->dbtype )
		{
#if	defined(SQLLIB_SUPPORT_PGLIB)
		case DBTYPE_PGLIB:
			if ( this->rep->db.pg_res != NULL )
			{
				delete (PgLib::Result *)this->rep->db.pg_res;
				this->rep->db.pg_res = NULL;
			}
			break;
#endif
		default:
			break;
		}
		this->rep->dbtype = DBTYPE_NONE;
	}
	return;
}

SqlLib::Result &	SqlLib::Result::operator = (const SqlLib::Result & right)
{
	if ( ((SqlLib::Result *)(&right))->check_rep() < 0 )
		return *this;
	++(right.rep->ref);
	if ( this->rep != NULL )
	{
		if ( --(this->rep->ref) == 0 )
		{
			this->destroy();
			delete this->rep;
			this->rep = NULL;
		}
	}
	this->rep = right.rep;
	return *this;
}

