//////////////////////////////////////////////////////////////////////////
//	"sqlvarbuf.cpp"
//------------------------------------------------------------------------
//	$Id: sqlvarbuf.cpp 11 2006-03-03 14:20:05Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"sqllib.h"
#include	<string.h>
#if	defined(WIN32)
# include	<tchar.h>
#endif

//////////////////////////////////////////////////////////////////////////
//	VarBuffer

SqlLib::VarBuffer::VarBuffer()
{
	this->buffersize = 0;
	this->validsize = 0;
	this->buffer = NULL;
}

SqlLib::VarBuffer::~VarBuffer()
{
	this->Clear();
}

void	SqlLib::VarBuffer::Clear(void)
{
	if ( this->buffer != NULL )
	{
		delete [] (unsigned char *)this->buffer;
		this->buffer = NULL;
	}
	this->buffersize = 0;
	this->validsize = 0;
}

int		SqlLib::VarBuffer::Add(unsigned size, const void * data)
{
	if ( this->validsize + size >= this->buffersize )
	{
		unsigned	newsize;
		void	   *newbuffer;

		newsize = ((this->validsize + size + LINE_BUFFER_SIZE - 1) / LINE_BUFFER_SIZE) * LINE_BUFFER_SIZE;
		if ( (newbuffer = new unsigned char [newsize]) == NULL )
			return -1;
		if ( this->buffer != NULL )
		{
			if ( this->validsize > 0 )
				::memcpy( newbuffer, this->buffer, this->validsize);
			delete [] (unsigned char *)this->buffer;
		}
		this->buffer     = newbuffer;
		this->buffersize = newsize;
	}
	if ( size > 0 && data != NULL )
	{
		::memcpy( (unsigned char *)this->buffer + this->validsize, data, size);
		this->validsize += size;
	}

	return 0;
}

int		SqlLib::VarBuffer::AddText(const TCHAR  * text)
{
	return this->Add((unsigned)_tcslen(text), text);
}

int		SqlLib::VarBuffer::AddChar(int ch)
{
	unsigned char	b;

	if ( ch >= 256 )
	{
		b = ch >> 8;
		if ( this->Add(sizeof(b), &b) < 0 )
			return -1;
	}
	b = ch & 0xFF;
	return this->Add( sizeof(b), &b);
}
