//////////////////////////////////////////////////////////////////////////
//	"vbuf_base64.cpp"
//------------------------------------------------------------------------
//	$Id: vbuf_base64.cpp 62 2006-03-26 17:45:52Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"varbuf.h"
#include	<stdlib.h>
#include	<string.h>

#if	defined(WIN32)
# include	<crtdbg.h>
#endif

#if	defined(_DEBUG) && defined(WIN32)
#	define	DBGREPORT(param_)	_CrtDbgReport param_
#else
#	define	DBGREPORT(param_)
# ifndef	_ASSERT
#	define	_ASSERT
# endif
#endif

#ifndef	EOLCODE
#	define	EOLCODE	"\r\n"
#endif

static const unsigned		base64tbl[64+1] =
{
	'A', 'B', 'C', 'D', 'E', 'F', 'G', 'H',
	'I', 'J', 'K', 'L', 'M', 'N', 'O', 'P',
	'Q', 'R', 'S', 'T', 'U', 'V', 'W', 'X',
	'Y', 'Z', 'a', 'b', 'c', 'd', 'e', 'f',
	'g', 'h', 'i', 'j', 'k', 'l', 'm', 'n',
	'o', 'p', 'q', 'r', 's', 't', 'u', 'v',
	'w', 'x', 'y', 'z', '0', '1', '2', '3',
	'4', '5', '6', '7', '8', '9', '+', '/',
	'='
};


unsigned 	VarBuffer::GetBase64Char(unsigned b)	// static
{
	return ::base64tbl[b & 63];
}

int		VarBuffer::Base64Encode(unsigned size, const void * buffer, VarBuffer & wbuf, unsigned maxlen)	// static
{
	unsigned	spos = 0, pos = 0;
	BYTE		*src = (BYTE *)buffer;
	BOOL		end = FALSE;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL,"SdbHttp::Base64Encode(size=%u,maxlen=%d)\n", size, maxlen));
	for (;;)
	{
		unsigned	code, prev;
		int			ch;

		// 1st byte
		if ( spos >= size )
			break;
		code = src[spos++] & 0xFF;
		ch = GetBase64Char( code >> 2 );
		prev = code;
		wbuf.AddChar(ch); pos++;

		// 2nd
		if ( spos >= size )
		{
			code = 0;
			end = TRUE;
		} else
			code = src[spos++] & 0xFF;
		ch = GetBase64Char( (prev<<4) | (code>>4) );
		prev =  code;
		wbuf.AddChar(ch); pos++;

		// 3rd
		if ( end )
		{
			ch = '=';
		} else
		{
			if ( spos >= size )
			{
				code = 0;
				end = TRUE;
			} else
				code = src[spos++] & 0xFF;
			ch = GetBase64Char((prev<<2) | (code>>6) );
			prev = code;
		}
		wbuf.AddChar(ch); pos++;

		// 4th
		if ( end )
			ch = '=';
		else
			ch = GetBase64Char(prev);
		wbuf.AddChar(ch); pos++;
		if ( maxlen > 0 && pos >= maxlen )
		{
			wbuf.Add((unsigned)strlen(EOLCODE), EOLCODE);
			pos = 0;
		}
	}

	return 0;
}
