//////////////////////////////////////////////////////////////////////////
//	"devctl.cpp"
//------------------------------------------------------------------------
//	$Id: devctl.cpp 17 2006-03-04 03:33:26Z taro $
//////////////////////////////////////////////////////////////////////////

#if	defined(LINUX)
//#define _FILE_OFFSET_BITS	64
//#define	__USE_LARGEFILE64
#endif
#include	"devctl.h"
#include	<linux/hdreg.h>
#include	<linux/cdrom.h>

DevCtl::DevCtl()
{
	this->devname = NULL;
	this->fd = -1;
	this->htype = HT_UNKNOWN;
	this->rwmode = 0;

	// scsi
	this->scsi_timeout = SCSI_TIMEOUT_SEC * 100;
}

DevCtl::~DevCtl()
{
}

int		DevCtl::OpenDevice(const TCHAR *name, unsigned rwmode)
{
	unsigned	mode;

	if ( this->fd != -1 )
		return -1;
	this->htype = HT_UNKNOWN;
	this->rwmode = rwmode;
	switch ( rwmode & (RW_READ|RW_WRITE) )
	{
		case RW_READ :
			mode = O_RDONLY;
			break;
		case RW_WRITE:
		case RW_READ|RW_WRITE:
			mode = O_RDWR;
			break;
		default:
			return -1;
	}
	if ( rwmode & RW_SYNC )
		rwmode |= O_SYNC;
	if ( rwmode & RW_NONBLOCK )
		rwmode |= O_NONBLOCK;
	if ( this->devname != NULL )
		delete [] this->devname;
	if ( (this->devname= new TCHAR [_tcslen(name)+1]) == NULL )
		return -1;
	_tcscpy(this->devname, name);

	if ( (this->fd = open(this->devname, mode)) < 0 )
	{
		this->fd = -1;
		return -1;
	}
	if ( fstat(this->fd, &this->statbuf) < 0 )
	{
		close(this->fd);
		this->fd = -1;
		return -1;
	}
	{
		int		ver;

		if ( (ioctl(this->fd, SG_GET_VERSION_NUM, &ver) >= 0) && (ver >= 30000))
			this->htype = HT_SG;
	}

	if ( this->htype == HT_UNKNOWN && S_ISBLK(this->statbuf.st_mode) )
		return this->blkdev_opendevice();

	if ( this->htype == HT_UNKNOWN && S_ISREG(this->statbuf.st_mode) )
	{	// normal file
		off_t	pos;

		this->htype = HT_FILE;
		this->blk.blkLen = 512;
		this->blk.blkNum = 0;
		pos = lseek(this->fd, (off_t)0, SEEK_END);
		if ( pos > 0 )
			this->blk.blkNum = (Int64)pos / (Int64)this->blk.blkLen;
		lseek(this->fd, (off_t)0, SEEK_SET);
	}

	return 0;
}

int		DevCtl::CloseDevice(void)
{
	if ( this->fd == -1 )
		return -1;
	close(this->fd);
	this->fd = -1;
	return 0;
}

