//////////////////////////////////////////////////////////////////////////
//	"sdbdev_file.h"
//------------------------------------------------------------------------
//	$Id: sdbdev_file.cpp 81 2006-03-29 16:19:03Z taro $
//////////////////////////////////////////////////////////////////////////

#include	"../include/sdblib.h"
#if	defined(WIN32)
# include	"../win32/devctl.h"
# include	<crtdbg.h>
#else
# include	<ctype.h>
#endif

#if	defined(_DEBUG) && defined(WIN32)
#	define	DBGREPORT(param_)	_CrtDbgReport param_
#else
#	define	DBGREPORT(param_)
# ifndef	_ASSERT
#	define	_ASSERT
# endif
#endif

int		SdbDev::SmartUpdateFile(sdb::DBDevData & devdata, const TCHAR * path)
{
	SdbLib				*sdblib = this->dbdev->GetSdbLib();
	sdb::FileHandle		fh = sdb::Invalid_FileHandle_Value;
	sdb::DBSmtData		smtdata;
	int					i, j;

	_ASSERT(sdblib != NULL);
	fh = sdb::FileOpen(path, sdb::FOM_APPEND);
	if ( sdb::IsFileHandleValid(fh) == FALSE )
		return -1;

	sdb::GetSystemTime(smtdata.smt_ts);
	smtdata.smt_dev_id = devdata.dev_id;
	for ( i = 0; i < DevCtl::NUMBER_ATA_SMART_ATTRIBUTES; i++ )
	{
		if ( this->smart.val->device_attribute[i].id == 0 )
			continue;	// not use
		smtdata.smt_attr_id   = this->smart.val->device_attribute[i].id; 
		smtdata.smt_value     = this->smart.val->device_attribute[i].value;
		smtdata.smt_worst     = this->smart.val->device_attribute[i].worst;
		smtdata.smt_threshold = 0;
		smtdata.smt_flags     = sdb::ATA_GET16(this->smart.val->device_attribute[i].flags);
		if ( this->smart.thr != NULL )
		{	// search threshhold
			for ( j = 0; j < DevCtl::NUMBER_ATA_SMART_ATTRIBUTES; j++ )
			{
				if ( this->smart.thr->threshhold_attribute[i].id == smtdata.smt_attr_id )
				{
					smtdata.smt_threshold = this->smart.thr->threshhold_attribute[i].threshold;
					break;
				}
			}
		}
		for ( j = 0; j < sizeof(smtdata.smt_raw_data)/sizeof(*smtdata.smt_raw_data); j++ )
			smtdata.smt_raw_data[j] = this->smart.val->device_attribute[i].raw[j];
		smtdata.smt_raw_value = this->smart.attrList.GetSmartRawValue(this->smart.val->device_attribute[i]);

		{
			SQStr		text;

			sdb::FileSeek(fh, I64(0), SEEK_END);
			sdblib->GetLogText(text, devdata, smtdata);
			sdb::FileWrite(fh, text.GetLength() * sizeof(TCHAR), text.GetText() );
		}
	}
	if ( sdb::IsFileHandleValid(fh) != FALSE )
		sdb::FileClose(fh);

	return 0;
}
