//////////////////////////////////////////////////////////////////////////
//	"devsmart.cpp"
//------------------------------------------------------------------------
//	$Id: devsmart.cpp 38 2006-03-07 02:45:24Z taro $
//////////////////////////////////////////////////////////////////////////

#include	<windows.h>
#include	<stddef.h>
#include	<tchar.h>
#include	<stdio.h>
#include	<ctype.h>
#include	"devctl.h"
#if defined(WIN32)
# include	<crtdbg.h>
#elif defined(LINUX)
# include	<assert.h>
# define	_ASSERT
#endif

#if defined(_DEBUG) && defined(WIN32)
# define	DBGREPORT(param_)	_CrtDbgReport param_
#else
# define	DBGREPORT(param_)
#endif

int		DevCtl::SmartGetVersion(GETVERSIONINPARAMS & ver)
{
	DWORD	dwRet;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL, "DevCtl::SmartGetVersion()\n"));
	memset(&ver, 0, sizeof(ver));
	if ( this->DeviceIoControl(SMART_GET_VERSION
	  , NULL, 0
	  , &ver, sizeof(ver)
	  , &dwRet) == FALSE )
		return -1;
	return 0;
}

int		DevCtl::SmartIoControl(DevCtl::SmartIoCtl ioctl, unsigned inp_size, SENDCMDINPARAMS * inp_buffer, unsigned out_size, SENDCMDOUTPARAMS * out_buffer)
{
	DWORD	dwRet;

	DBGREPORT((_CRT_WARN,NULL,NULL,NULL, "DevCtl::SmartIoControl()\n"));
	if ( inp_size == 0 || inp_buffer == NULL || out_size == 0 || out_buffer == NULL )
		return -1;
	if ( this->DeviceIoControl(ioctl
	  , inp_buffer, inp_size
	  , out_buffer, out_size
	  , &dwRet) == FALSE )
		return -1;
	return (int)dwRet;
}

int			DevCtl::AtaReadIndentify(int drive, DevCtl::AtaIdentifyDevice & identify)
{
	SENDCMDINPARAMS		inp;
	BYTE				outbuf[sizeof(SENDCMDOUTPARAMS) - 1 + sizeof(identify)];
	SENDCMDOUTPARAMS	*out = (SENDCMDOUTPARAMS *) outbuf;
	unsigned			out_size = sizeof(outbuf);

	memset(&inp, 0, sizeof(inp));
	inp.cBufferSize                 = sizeof(inp);
	inp.irDriveRegs.bSectorCountReg = 1;
	inp.irDriveRegs.bCylLowReg      = 0;
	inp.irDriveRegs.bCylHighReg     = 0;
	inp.irDriveRegs.bDriveHeadReg   = 0xA0 | ((drive & 1) << 4);
	inp.irDriveRegs.bCommandReg     = ATA_IDENTIFY_DEVICE;
	inp.bDriveNumber                = drive;

	memset(out, 0, out_size);
	if ( this->SmartIoControl(SMART_IOCTL_RCV, sizeof(inp), &inp, out_size, out) < 0 )
		return -1;
	memcpy(&identify, out->bBuffer, sizeof(identify));

	return 0;
}

int		DevCtl::SmartReadValues(int drive, DevCtl::AtaSmartValues & val)
{
	SENDCMDINPARAMS		inp;
	BYTE				outbuf[sizeof(SENDCMDOUTPARAMS) - 1 + sizeof(val)];
	SENDCMDOUTPARAMS	*out = (SENDCMDOUTPARAMS *) outbuf;
	unsigned			out_size = sizeof(outbuf);

	memset(&inp, 0, sizeof(inp));
	inp.cBufferSize                  = sizeof(inp);
	inp.irDriveRegs.bFeaturesReg     = ATA_SMART_READ_VALUES;
	inp.irDriveRegs.bSectorCountReg  = 1;
	inp.irDriveRegs.bSectorNumberReg = 1;
	inp.irDriveRegs.bCylLowReg       = SMART_CYL_LOW;
	inp.irDriveRegs.bCylHighReg      = SMART_CYL_HI;
	inp.irDriveRegs.bDriveHeadReg    = 0xA0 | ((drive & 1) << 4);
	inp.irDriveRegs.bCommandReg      = ATA_SMART_CMD;
	inp.bDriveNumber                 = drive;

	memset(out, 0, out_size);
	if ( this->SmartIoControl(SMART_IOCTL_RCV, sizeof(inp), &inp, out_size, out) < 0 )
		return -1;
	memcpy(&val, out->bBuffer, sizeof(val));

	return 0;
}

int		DevCtl::SmartReadThresholds(int drive, DevCtl::AtaSmartThresholds & thr)
{
	SENDCMDINPARAMS		inp;
	BYTE				outbuf[sizeof(SENDCMDOUTPARAMS) - 1 + sizeof(thr)];
	SENDCMDOUTPARAMS	*out = (SENDCMDOUTPARAMS *) outbuf;
	unsigned			out_size = sizeof(outbuf);

	memset(&inp, 0, sizeof(inp));
	inp.cBufferSize                  = sizeof(inp);
	inp.irDriveRegs.bFeaturesReg     = ATA_SMART_READ_THRESHOLDS;
	inp.irDriveRegs.bSectorCountReg  = 1;
	inp.irDriveRegs.bSectorNumberReg = 1;
	inp.irDriveRegs.bCylLowReg       = SMART_CYL_LOW;
	inp.irDriveRegs.bCylHighReg      = SMART_CYL_HI;
	inp.irDriveRegs.bDriveHeadReg    = 0xA0 | ((drive & 1) << 4);
	inp.irDriveRegs.bCommandReg      = ATA_SMART_CMD;
	inp.bDriveNumber                 = drive;

	memset(out, 0, out_size);
	if ( this->SmartIoControl(SMART_IOCTL_RCV, sizeof(inp), &inp, out_size, out) < 0 )
		return -1;
	memcpy(&thr, out->bBuffer, sizeof(thr));

	return 0;
}
